#Basic graphics stuff
master = Tk()

#Get screen size
screen_width = master.winfo_screenwidth()
screen_height = master.winfo_screenheight()

#Make window fullscreen
master.attributes("-fullscreen", True)

#Setup canvas
display = Canvas(master, width=screen_width, height=screen_height)
display.pack()
display.focus_set()

#Define colors
black = "#000000"
white = "#fff"

#Prepare for drawing apps
global appicons
appicons = []

global clock

#Graphics functions
def createDialog(message):
    display.create_rectangle(screen_width / 2 - 128, screen_height / 2 - 64, screen_width / 2 + 128, screen_height / 2 + 64, fill = black)
    display.create_text(screen_width / 2, screen_height / 2, fill = white, text = message, width=236)

def launchApp(event):
    item = display.find_closest(event.x, event.y)
    filename = ''.join(display.gettags(item))[:-7]
    app("apps/" + filename)

def launchSysApp(event):
    item = display.find_closest(event.x, event.y)
    filename = ''.join(display.gettags(item))[:-7]
    app("sys/" + filename)

def drawAppIcon(x, y, app, sys):
    global appicons
    appConfig = json.load(open("apps/" + app + "-config.json"))
    if(appConfig["icon"] == "none"):
        save = display.create_rectangle(x, y, x + 256, y + 256, fill = appConfig["bgcolor"], tags = appConfig["file"])
        display.create_text(x + 128, y + 128, text = appConfig["displayname"], fill = white)
    else:
        save = display.create_image(x, y, image = PhotoImage(file = appConfig["icon"]), tags = appConfig["file"])

    appicons.append(save)
    if(sys == False):
        display.tag_bind(appicons[len(appicons) - 1], '<ButtonPress-1>', launchApp)
    else:
        display.tag_bind(appicons[len(appicons) - 1], '<ButtonPress-1>', launchSysApp)

def updateClock():
    global clock
    display.delete(clock)
    clock = display.create_text(3, 3, text = strftime("%H:%M", localtime()), fill = black, anchor = NW) #Draw version on status bar
    master.after(1000, updateClock)

def drawHome():
    global clock
    display.delete(all)
    display.create_rectangle(0, 0, screen_width, screen_height, fill = white) #Draw Background
    display.create_rectangle(0, 0, screen_width, 18, fill = "#c9ced6", outline = "#c9ced6")
    clock = display.create_text(3, 3, text = strftime("%H:%M", localtime()), fill = black, anchor = NW) #Draw clock on status bar
    updateClock()
    drawAppIcon(64, 64, "testapp", False)
    #Not working \/
    #drawAppIcon(336, 64, "terminal", True)
